--- old/usr/src/uts/common/fs/sockfs/sockcommon_vnops.c	2015-08-09 12:47:45.392690611 +0300
+++ new/usr/src/uts/common/fs/sockfs/sockcommon_vnops.c	2015-08-09 12:47:45.402729201 +0300
@@ -123,6 +123,8 @@
 	so->so_count++;
 	mutex_exit(&so->so_lock);
 
+	sonode_insert_pid(so, curproc);
+
 	ASSERT(so->so_count != 0);	/* wraparound */
 	ASSERT(vp->v_type == VSOCK);
 
@@ -209,6 +211,22 @@
 
 	ASSERT(vp->v_type == VSOCK);
 
+	switch (cmd) {
+		case F_FORKED: {
+			if (cr != kcred)
+				return (-1);
+			sonode_insert_pid(so, (proc_t *)arg);
+			return (0);
+		}
+
+		case F_CLOSED: {
+			if (cr != kcred)
+				return (-1);
+			sonode_remove_pid(so, (proc_t *)arg);
+			return (0);
+		}
+	}
+
 	return (socket_ioctl(so, cmd, arg, mode, cr, rvalp));
 }
 
